import { NgxPuzzleCanvasBaseComponent } from '../base/ngx-puzzle-canvas-base.component';
import { PuzzleCanvasMediatorService, ComponentConfig, ComponentControlProps, ControlConfig, ControlTypesEnum, DataRequestConfig, mainTypes, SafeAny } from 'ngx-puzzle/core';
import * as i0 from "@angular/core";
export declare class NgxPuzzleControlComponent extends NgxPuzzleCanvasBaseComponent<ComponentControlProps, ControlTypesEnum> {
    private controlService;
    zIndex: import("@angular/core").WritableSignal<number>;
    dataKey: mainTypes;
    set config(config: ComponentConfig<ComponentControlProps, ControlTypesEnum>);
    get config(): ComponentConfig<ComponentControlProps, ControlTypesEnum>;
    get control(): ControlConfig;
    controlValue: SafeAny;
    constructor(mediator: PuzzleCanvasMediatorService<ComponentControlProps, ControlTypesEnum>);
    updateData(requestData: DataRequestConfig): void;
    controlValueChange(): void;
    initControlValue(): void;
    protected afterUpdateConfig(): void;
    protected getDefaultOptions(subType: ControlTypesEnum): {
        controlId: string;
        controlType?: ControlTypesEnum | undefined;
        alias?: string | undefined;
        props?: import("ngx-puzzle/core").BaseControlProps | undefined;
        label?: import("ngx-puzzle/core").ControlLabelConfig;
        bindField?: string;
        defaultValue?: any;
        isActive?: boolean | undefined;
    };
    panelOnShow(event: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxPuzzleControlComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxPuzzleControlComponent, "puzzle-control", never, {}, {}, never, never, true, never>;
}
